/*
  RF233 radio-Chip on In-Circuit radino RF233 modules
  for more information: www.in-circuit.de or www.radino.cc

  Copyright (c) 2015 In-Circuit GmbH

  Permission is hereby granted, free of charge, to any person obtaining a copy of this software
  and associated documentation files (the "Software"), to deal in the Software without restriction,
  including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense,
  and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT
  LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
  IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
  WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/

#ifdef ARDUINO_ARCH_AVR

#ifndef __IC_RF233_H__
#define __IC_RF233_H__

#include "at86rf2xx.h"

#define ICRF233_IRQ_PIN 7  //within arduino:
#define ICRF233_IRQ_NUM 4  //INT6 -> int = 4
#define ICRF233_RESET 4
#define ICRF233_SLP_TR A4
#define ICRF233_SEL 8

#define ICRF233_PAKETSIZE AT86RF2XX_MAX_PKT_LENGTH+4

typedef struct __attribute__((packed))
{
  uint8_t len;
  uint8_t packetdata[ICRF233_PAKETSIZE];
  uint16_t appended;
} transfer_t;


class IC_RF233 : public AT86RF2XX
{
  public:
//     float setFrequency(float desiredFreq) {}
//     unsigned long setDatarate(unsigned long desiredDatarate) {}
//     unsigned char setPaTable(unsigned char newValue) {}
//     uint8_t wait_CCA(uint32_t timeout, uint32_t gap_us) {}
//     unsigned char Transmit_wCCA(const unsigned char *txBuf, unsigned char cnt, uint32_t timeout, uint32_t gap_us) {}
//     
     void Init(unsigned char maxPacketLength, uint32_t receiveTimeout)
     {
       AT86RF2XX::init(ICRF233_SEL, ICRF233_IRQ_PIN, ICRF233_SLP_TR, ICRF233_RESET, ICRF233_IRQ_NUM);
       //AT86RF2XX::set_chan(26); // set channel to 26
     }
//     void Reset (void) {}
//     uint8_t GetState(void) {}
//     unsigned char ReadState(void) {}
//     unsigned char Sleep(void) {set_state(AT86RF2XX_STATE_SLEEP);}
//     void ForceIdle(void) {}
//     unsigned char StartReceive(unsigned long timeout_ms = 0) {}
//     unsigned char StopReceive(void) {}
//     
//     //get RXFIFO content if any
//     unsigned char GetData(unsigned char *rxBuf) {}
//     //start packet transmission
//     unsigned char Transmit(const unsigned char *txBuf, unsigned char cnt) {}
//     unsigned char TXBusy(void) {}
//     //get RXFIFO content if any else start listening
//     unsigned char ReadPacket(unsigned char *rxBuf) {}
//     //stop receive then start packet transmission
//     unsigned char SendPacket(const unsigned char *txBuf, unsigned char cnt) {}
// 
//     void setAddressFilter(uint8_t address) {}
};

#endif

#endif